
;         DMA-vezrl felprogramozsa

; ES:DI=Az tvitel kezdcme (szegmens:offset)
; CX=Az tvitel hossza (byte-ok szma - 1)
; DH=Az tvitel mdja
; AH=A hasznlni kvnt DMA-csatorna

DMASet	Proc
	pusha

	mov si, es           ; szegmens:offset cm konvertlsa
	shl si, 4            ; lap:offset cmm
	mov bx, es
	shr bx, 12
	mov dl, bl           ; DL-be kerl a lap
	add si, di
	adc dl, 0            ; a lapszm nvelse a tvitellel
	mov bx, si           ; BX-be kerl az offset

	cmp ah, 4
	jb ^DMA8

^DMA16:
	SHR BX//IF DL&1 THENCMD BH|=80H
;;	--CX

	mov al, ah
	out 0d4h, al         ; a maszkregiszter belltsa

	xor al, al
	out 0d8h, al         ; a bels mutatk trlse

	mov al, ah
	sub al, 4
	add al, dh ; MODE
	out 0d6h, al         ; a mdregiszter belltsa

	push dx

	xor dx, dx
	mov dl, ah
	sub dl, 4 ; DL=0..3
	shl dl, 2
	add dl, 0c0h         ; a portcm kiszmtsa a csatornaszmbl
	mov al, bl
	out dx, al
	mov al, bh
	out dx, al           ; a kezdcm kirsa

	add dl, 2
	mov al, cl
	out dx, al
	mov al, ch
	out dx, al           ; az tvitel hossznak kirsa

	pop dx

	mov al, dl ; PAGE
	mov bl, ah ;; BX=PAGE_PORT
	xor bh, bh ;;
	xor dh, dh
	mov dl, dma_page_tabl[bx]
	out dx, al           ; a lapregiszter belltsa

	mov al, ah
	sub al, 4
	out 0d4h, al         ; a maszkbit trlse

	popa
	ret

^DMA8:
	mov al, ah
	add al, 4
	out 0ah, al         ; a maszkregiszter belltsa

	xor al, al
	out 0ch, al         ; a bels mutatk trlse

	mov al, ah
	add al, dh
	out 0bh, al         ; a mdregiszter belltsa

	push dx

	xor dx, dx
	mov dl, ah           ; a portcm kiszmtsa a csatornaszmbl
	shl dl, 1
	mov al, bl
	out dx, al
	mov al, bh
	out dx, al           ; a kezdcm kirsa

	inc dl
	mov al, cl
	out dx, al
	mov al, ch
	out dx, al           ; az tvitel hossznak kirsa

	pop dx

	mov al, dl
	mov bl, ah
	xor bh, bh
	xor dh, dh
	mov dl, dma_page_tabl[bx]
	out dx, al           ; a lapregiszter belltsa

	mov al, ah
	out 0ah, al         ; a maszkbit trlse

	popa
	ret

;;dma_page_tabl db 87h, 83h, 81h, 82h, 8bh, 89h, 8ah, 8fh  ; HIBS!!!!
dma_page_tabl db 87h, 83h, 81h, 82h, 8Fh, 8Bh, 89h, 8Ah

DMASet	EndP
